<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
    require_once BASEDIR . "maincore.php";
    require_once BASEDIR . "subheader.php";
    require_once BASEDIR . "side_left.php";
    if(file_exists(INFUSIONS."aw_boinc_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."aw_boinc_panel/locale/".$settings['locale'].".php";
    } else {
	include INFUSIONS."aw_boinc_panel/locale/English.php";
    }

    /* FUNCTIONS */
    function parse_wap($data0) {
	if(strcmp(substr($data0, 0, 5), "<?xml") != 0) {
	    return $empty_info;
	}
//	echo "<p>" . htmlspecialchars($data0);

	$data0 = ereg_replace("^.*<p>", "", $data0);
//	echo "<p>" . htmlspecialchars($data0);

	$data0 = ereg_replace("<br/></p>.*$", "", $data0);
//	echo "<p>" . htmlspecialchars($data0);

	$lines = explode("<br/>", $data0);
	$linecount = count($lines);

	// parse
	foreach($lines as $line) {
	    if(!empty($line)) {
		// try to split at ": "
		$key_and_value = explode(": ", $line);
		if(count($key_and_value)==2) {
		    switch($key_and_value[0]) {
		    case "User TotCred":
			$info['credits'] = $key_and_value[1];
			break;
		    case "User AvgCred":
			$info['ave_credits'] = $key_and_value[1];
			break;
		    case "Team":
			$info['group'] = $key_and_value[1];
			break;
		    default:
			continue;
		    }
		}
		// try to split at " "
		if(strcmp(substr($line, 0, 4), "for ") == 0) {
		    $info['name'] = substr($line, 4);
		// REST
		} else {
		    $info['type'] = $line;
		}
	    }
	}

	return $info;
    }

/*
    function write_to_file($data) {
	$boinc_id = fopen("meine_texte/boinc_file", "w");
	if($boinc_id && true===fwrite($boinc_id, $data))
	    return true;
	return false;
    }
*/

    function show_info($info, $url, $id) {
	global $locale;
	echo "<pre>";

	if(count($info) == 0) {
	    echo "<b>$id</b>\n";
	    echo "  "  . $locale['aw_no_userid'] . "\n";
	    return;
	}

	echo "<a href='$url' target='_blank'>" . $info['name'] . "</a>\n";
	echo "  TC: " . $info['credits'] . "\n";
	echo "  AV: " . $info['ave_credits'] . "\n";
	echo "   T: " . $info['group'];

	echo "</pre>\n";
	/*FIXME
	echo "<tr>\n";

	if(count($info) == 0) {
	    echo "<td>$id</td>\n";
	    echo "<td colspan='3'>" . $locale['aw_no_userid'] . "</td>\n";
	    return;
	}

	echo "<td colspan='3'><a href='$url' target='_blank'>" . $info['name'] . "</a></td>\n";
	echo "<tr>\n";
	echo "<td></td>";
	echo "<td>" . $info['credits'] . "</td>";
	echo "<td>" . $info['ave_credits'] . "</td>";
	echo "<td>" . $info['group'] . "</td>\n";
	*/
    }


    openside($locale['aw_title']);


    // database
    $query = "SELECT * FROM " . $db_prefix . "aw_boinc_users"
	. " WHERE activated='Y'";
    $query_id = dbquery($query);

    while($query_id && $user=dbarray($query_id)) {
	$boinc_id = $user['id'];
	// FIXME
	$url = "http://setiathome.berkeley.edu/show_user.php?userid=$boinc_id";

	// retreive once every hour. so check last update.
	// less, so get from the database.
	if((time()-$user['last_updated']) < 3600) {
	    $info['name'] = $user['last_name'];
	    $info['credits'] = $user['last_credits'];
	    $info['ave_credits'] = $user['last_average_credits'];
	    $info['group'] = $user['last_group'];

	// greater, so get from boinc server.
	} else {
	    // retrieve information from server.
	    // FIXME
	    $wap_url = "http://setiathome.berkeley.edu/userw.php?id=$boinc_id";
	    $aw_url = $wap_url;

	    if(!empty($boinc_id) && $id=@fopen($aw_url, "r")) {
		$data0 = fread($id, 4096);
		//write_to_file($data0);
		$info = parse_wap($data0);
		$update_query = "UPDATE $db_prefix" . "aw_boinc_users"
		    . " SET last_updated='" . time() . "', "
		    . " last_name='" . $info['name'] . "', "
		    . " last_credits='" . $info['credits'] . "', "
		    . " last_average_credits='" . $info['ave_credits'] . "', "
		    . " last_group='" . $info['group'] . "'"
		    . " WHERE id='" . $boinc_id . "'";
//		echo $update_query;
		dbquery($update_query);
	    } else {
		echo "<div align='center'><font color='red'>";
		if(!$id)
		    echo $locale['aw_no_conection'];
		else
		    echo $locale['aw_no_userid'];
		echo "</font></div>\n";
	    }
	}

/*FIXME
	echo "<table width='100%' cellspacing='1' cellpadding='0' border='0'>\n";
	echo "<tr><td>" . $locale['aw_user'] . "</td><td>C</td><td>AC</td><td>G</td>\n";
	*/
	show_info($info, $url, $boinc_id);
	/*FIXME
	echo "</table>\n";
	*/
    }


    closeside();
?>

